<!--
    Input:
        device/mediatek/system/common/device_framework_matrix.xml
-->
<compatibility-matrix version="7.0" type="framework">
    <hal format="aidl" optional="true">
        <name>android.hardware.biometrics.fingerprint</name>
        <version>3</version>
        <interface>
            <name>IFingerprint</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>android.hardware.bluetooth</name>
        <interface>
            <name>IBluetoothHci</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>android.hardware.camera.provider</name>
        <interface>
            <name>ICameraProvider</name>
            <instance>internal/0</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.radio</name>
        <version>1.2</version>
        <version>1.6</version>
        <interface>
            <name>IRadio</name>
            <instance>em1</instance>
            <instance>em2</instance>
            <instance>em3</instance>
            <instance>em4</instance>
            <instance>imsAospSlot1</instance>
            <instance>imsAospSlot2</instance>
            <instance>imsAospSlot3</instance>
            <instance>imsAospSlot4</instance>
            <instance>se1</instance>
            <instance>se2</instance>
            <instance>se3</instance>
            <instance>se4</instance>
            <instance>slot1</instance>
            <instance>slot2</instance>
            <instance>slot3</instance>
            <instance>slot4</instance>
        </interface>
        <interface>
            <name>ISap</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
            <instance>slot3</instance>
            <instance>slot4</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.radio.config</name>
        <version>1.3</version>
        <interface>
            <name>IRadioConfig</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>android.hardware.radio.config</name>
        <version>1-2</version>
        <interface>
            <name>IRadioConfig</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>android.hardware.radio.data</name>
        <version>1-2</version>
        <interface>
            <name>IRadioData</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
            <instance>slot3</instance>
            <instance>slot4</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>android.hardware.radio.ims</name>
        <interface>
            <name>IRadioIms</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
            <instance>slot3</instance>
            <instance>slot4</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>android.hardware.radio.messaging</name>
        <version>1-2</version>
        <interface>
            <name>IRadioMessaging</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
            <instance>slot3</instance>
            <instance>slot4</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>android.hardware.radio.modem</name>
        <version>1-2</version>
        <interface>
            <name>IRadioModem</name>
            <instance>imsSlot1</instance>
            <instance>imsSlot2</instance>
            <instance>imsSlot3</instance>
            <instance>imsSlot4</instance>
            <instance>se1</instance>
            <instance>se2</instance>
            <instance>se3</instance>
            <instance>se4</instance>
            <instance>slot1</instance>
            <instance>slot2</instance>
            <instance>slot3</instance>
            <instance>slot4</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>android.hardware.radio.network</name>
        <version>1-2</version>
        <interface>
            <name>IRadioNetwork</name>
            <instance>imsSlot1</instance>
            <instance>imsSlot2</instance>
            <instance>imsSlot3</instance>
            <instance>imsSlot4</instance>
            <instance>slot1</instance>
            <instance>slot2</instance>
            <instance>slot3</instance>
            <instance>slot4</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>android.hardware.radio.sap</name>
        <interface>
            <name>ISap</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
            <instance>slot3</instance>
            <instance>slot4</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>android.hardware.radio.sim</name>
        <version>1-2</version>
        <interface>
            <name>IRadioSim</name>
            <instance>imsSlot1</instance>
            <instance>imsSlot2</instance>
            <instance>imsSlot3</instance>
            <instance>imsSlot4</instance>
            <instance>se1</instance>
            <instance>se2</instance>
            <instance>se3</instance>
            <instance>se4</instance>
            <instance>slot1</instance>
            <instance>slot2</instance>
            <instance>slot3</instance>
            <instance>slot4</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>android.hardware.radio.voice</name>
        <version>1-2</version>
        <interface>
            <name>IRadioVoice</name>
            <instance>imsSlot1</instance>
            <instance>imsSlot2</instance>
            <instance>imsSlot3</instance>
            <instance>imsSlot4</instance>
            <instance>slot1</instance>
            <instance>slot2</instance>
            <instance>slot3</instance>
            <instance>slot4</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>android.hardware.soundtrigger3</name>
        <interface>
            <name>ISoundTriggerHw</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>arm.mali.platform</name>
        <version>1-2</version>
        <interface>
            <name>ICompression</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.aee</name>
        <version>1.1</version>
        <interface>
            <name>IAee</name>
            <instance>AEE</instance>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.aee</name>
        <interface>
            <name>IAee</name>
            <instance>AEE</instance>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.apmonitor</name>
        <version>2.0</version>
        <interface>
            <name>IApmService</name>
            <instance>apm_hidl_service</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.apmonitor</name>
        <interface>
            <name>IApmService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.apuware.apusys</name>
        <version>1.0</version>
        <version>2.0</version>
        <version>2.1</version>
        <interface>
            <name>INeuronApusys</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.apuware.apusys</name>
        <version>1</version>
        <version>2</version>
        <interface>
            <name>INeuronApusys</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.apuware.hmp</name>
        <version>1.0</version>
        <interface>
            <name>IApuwareHmp</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.apuware.utils</name>
        <version>1.0</version>
        <version>2.0</version>
        <interface>
            <name>IApuwareUtils</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.apuware.utils</name>
        <interface>
            <name>IApuwareUtils</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.apuware.xrp</name>
        <version>1.0</version>
        <version>2.0</version>
        <interface>
            <name>INeuronXrp</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.atci</name>
        <version>1.0</version>
        <interface>
            <name>IAtcid</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.atci</name>
        <interface>
            <name>IAtcid</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.audio</name>
        <interface>
            <name>IMtkAudio</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.bluetooth.audio</name>
        <version>2.1</version>
        <version>2.2</version>
        <interface>
            <name>IBluetoothAudioProvidersFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.bluetooth.audio</name>
        <interface>
            <name>IBluetoothAudioProviderFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.camera.aovservice</name>
        <version>1-2</version>
        <interface>
            <name>IAovService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.camera.atms</name>
        <version>1.0</version>
        <interface>
            <name>IATMs</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.camera.atms</name>
        <interface>
            <name>IATMs</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.camera.bgservice</name>
        <version>1.1</version>
        <interface>
            <name>IBGService</name>
            <instance>internal/0</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.camera.bgservice</name>
        <interface>
            <name>IBGService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.camera.ccap</name>
        <version>1.0</version>
        <interface>
            <name>ICCAPControl</name>
            <instance>internal/0</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.camera.isphal</name>
        <version>1.1</version>
        <interface>
            <name>IISPModule</name>
            <instance>internal/0</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.camera.isphal</name>
        <interface>
            <name>IISPModule</name>
            <instance>internal/1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.camera.postproc</name>
        <version>1.0</version>
        <interface>
            <name>IPostDevice</name>
            <instance>internal/0</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.clientapi</name>
        <version>1.0</version>
        <interface>
            <name>IClientapi</name>
            <instance>clientapi_hal_service</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.clientapi</name>
        <interface>
            <name>IClientApi</name>
            <instance>clientapi_aidl_service</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.composer_ext</name>
        <version>1.0</version>
        <interface>
            <name>IComposerExt</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.composer_ext</name>
        <interface>
            <name>IComposerExt</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.dfps</name>
        <version>1.0</version>
        <interface>
            <name>IFpsPolicyService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.dmc</name>
        <version>1.2</version>
        <interface>
            <name>IDmcService</name>
            <instance>dmc_hidl_service</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.dmc</name>
        <interface>
            <name>IDmcService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.dplanner</name>
        <version>2.0</version>
        <interface>
            <name>IDPlanner</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.dplanner2</name>
        <interface>
            <name>IDPlanner</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.engineermode</name>
        <version>1.3</version>
        <interface>
            <name>IEmd</name>
            <instance>EmHidlServer</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.engineermode</name>
        <interface>
            <name>IEmds</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.gnss</name>
        <interface>
            <name>IMtkGnss</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.gnss.batching</name>
        <interface>
            <name>IMtkGnssBatching</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.gpu</name>
        <version>1.0</version>
        <interface>
            <name>IGraphicExt</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.gpuserv</name>
        <interface>
            <name>IGpuService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.hdcpwifidisplay</name>
        <version>1.0</version>
        <interface>
            <name>IHDCPWIFIDisplay</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.hdmi</name>
        <version>1.4</version>
        <interface>
            <name>IMtkHdmiService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.hdmi_aidl</name>
        <interface>
            <name>IMtkHdmiService_AIDL</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.imsa</name>
        <version>1.0</version>
        <interface>
            <name>IImsa</name>
            <instance>imsa</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.interfaces_tc1.mtkradioex_tc1</name>
        <version>3.0</version>
        <interface>
            <name>IMtkRadioEx</name>
            <instance>mtkAssist1</instance>
            <instance>mtkAssist2</instance>
            <instance>mtkCap1</instance>
            <instance>mtkCap2</instance>
            <instance>mtkEm1</instance>
            <instance>mtkEm2</instance>
            <instance>mtkSe1</instance>
            <instance>mtkSe2</instance>
            <instance>mtkSlot1</instance>
            <instance>mtkSlot2</instance>
            <instance>mtkSmartRatSwitch1</instance>
            <instance>mtkSmartRatSwitch2</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.keymanage</name>
        <version>1.0</version>
        <interface>
            <name>IKeymanage</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.keymaster_attestation</name>
        <version>1.1</version>
        <interface>
            <name>IKeymasterDevice</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.lbs</name>
        <version>1.0</version>
        <interface>
            <name>ILbs</name>
            <instance>AgpsDebugInterface</instance>
            <instance>AgpsInterface</instance>
            <instance>mtk_agps2framework</instance>
            <instance>mtk_agpsd2debugService</instance>
            <instance>mtk_debugService2agpsd</instance>
            <instance>mtk_debugService2mnld</instance>
            <instance>mtk_framework2agps</instance>
            <instance>mtk_jam2mnl</instance>
            <instance>mtk_lbs_log_v2s</instance>
            <instance>mtk_lppe_socket_agps</instance>
            <instance>mtk_lppe_socket_bt</instance>
            <instance>mtk_lppe_socket_ipaddr</instance>
            <instance>mtk_lppe_socket_lbs</instance>
            <instance>mtk_lppe_socket_network</instance>
            <instance>mtk_lppe_socket_sensor</instance>
            <instance>mtk_lppe_socket_wlan</instance>
            <instance>mtk_meta2mnld</instance>
            <instance>mtk_mnl2jam</instance>
            <instance>mtk_mnld2debugService</instance>
            <instance>mtk_mnld2mtklogger</instance>
            <instance>mtk_mnld2nlputils</instance>
            <instance>mtk_mtklogger2mnld</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.lbs</name>
        <interface>
            <name>ILbs</name>
            <instance>AgpsDebugInterface</instance>
            <instance>AgpsInterface</instance>
            <instance>mtk_agps2framework</instance>
            <instance>mtk_agpsd2debugService</instance>
            <instance>mtk_debugService2agpsd</instance>
            <instance>mtk_debugService2mnld</instance>
            <instance>mtk_framework2agps</instance>
            <instance>mtk_jam2mnl</instance>
            <instance>mtk_lbs_log_v2s</instance>
            <instance>mtk_lppe_socket_agps</instance>
            <instance>mtk_lppe_socket_bt</instance>
            <instance>mtk_lppe_socket_ipaddr</instance>
            <instance>mtk_lppe_socket_lbs</instance>
            <instance>mtk_lppe_socket_network</instance>
            <instance>mtk_lppe_socket_sensor</instance>
            <instance>mtk_lppe_socket_wlan</instance>
            <instance>mtk_meta2mnld</instance>
            <instance>mtk_mnl2jam</instance>
            <instance>mtk_mnld2debugService</instance>
            <instance>mtk_mnld2mtklogger</instance>
            <instance>mtk_mnld2nlputils</instance>
            <instance>mtk_mtklogger2mnld</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.log</name>
        <version>1.0</version>
        <interface>
            <name>ILog</name>
            <instance>ATMWiFiHidlServer</instance>
            <instance>ConnsysFWHidlServer</instance>
            <instance>LoggerHidlServer</instance>
            <instance>MobileLogHidlServer</instance>
            <instance>ModemLogHidlServer</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.log</name>
        <interface>
            <name>ILog</name>
            <instance>ATMWiFiHidlServer</instance>
            <instance>ConnsysFWHidlServer</instance>
            <instance>LoggerHidlServer</instance>
            <instance>MobileLogHidlServer</instance>
            <instance>ModemLogHidlServer</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.mbrain</name>
        <interface>
            <name>IMBrain</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.mbrainj</name>
        <interface>
            <name>IMBrainJava</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.mdmonitor</name>
        <version>1.0</version>
        <interface>
            <name>IMDMonitorService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.mdmonitor</name>
        <interface>
            <name>IMDMonitorService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.mmagent</name>
        <version>1.1</version>
        <interface>
            <name>IMMAgent</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.mmagent</name>
        <interface>
            <name>IMMAgent</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.mmlpq</name>
        <version>2-3</version>
        <interface>
            <name>IMmlpq</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.mms</name>
        <version>1.6-7</version>
        <interface>
            <name>IMms</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.mtkcodecservice</name>
        <version>1.1</version>
        <interface>
            <name>IMtkCodecService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.mtkpower</name>
        <version>1.2</version>
        <interface>
            <name>IMtkPerf</name>
            <instance>default</instance>
        </interface>
        <interface>
            <name>IMtkPower</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.mtkpower</name>
        <interface>
            <name>IMtkPowerService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.mtkpower_applist</name>
        <interface>
            <name>IMtkpower_applist</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.mtkradioex</name>
        <version>2.5</version>
        <interface>
            <name>IMtkRadioEx</name>
            <instance>imsSlot1</instance>
            <instance>imsSlot2</instance>
            <instance>imsSlot3</instance>
            <instance>imsSlot4</instance>
            <instance>mtkAssist1</instance>
            <instance>mtkAssist2</instance>
            <instance>mtkAssist3</instance>
            <instance>mtkAssist4</instance>
            <instance>mtkCap1</instance>
            <instance>mtkCap2</instance>
            <instance>mtkCap3</instance>
            <instance>mtkCap4</instance>
            <instance>mtkEm1</instance>
            <instance>mtkEm2</instance>
            <instance>mtkEm3</instance>
            <instance>mtkEm4</instance>
            <instance>mtkRcs1</instance>
            <instance>mtkRcs2</instance>
            <instance>mtkRcs3</instance>
            <instance>mtkRcs4</instance>
            <instance>mtkSe1</instance>
            <instance>mtkSe2</instance>
            <instance>mtkSe3</instance>
            <instance>mtkSe4</instance>
            <instance>mtkSlot1</instance>
            <instance>mtkSlot2</instance>
            <instance>mtkSlot3</instance>
            <instance>mtkSlot4</instance>
            <instance>mtkSmartRatSwitch1</instance>
            <instance>mtkSmartRatSwitch2</instance>
            <instance>mtkSmartRatSwitch3</instance>
            <instance>mtkSmartRatSwitch4</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.mtkradioex</name>
        <version>3.0</version>
        <interface>
            <name>IMtkRadioEx</name>
            <instance>imsSlot1</instance>
            <instance>imsSlot2</instance>
            <instance>imsSlot3</instance>
            <instance>imsSlot4</instance>
            <instance>mtkAssist1</instance>
            <instance>mtkAssist2</instance>
            <instance>mtkAssist3</instance>
            <instance>mtkAssist4</instance>
            <instance>mtkCap1</instance>
            <instance>mtkCap2</instance>
            <instance>mtkCap3</instance>
            <instance>mtkCap4</instance>
            <instance>mtkEm1</instance>
            <instance>mtkEm2</instance>
            <instance>mtkEm3</instance>
            <instance>mtkEm4</instance>
            <instance>mtkRcs1</instance>
            <instance>mtkRcs2</instance>
            <instance>mtkRcs3</instance>
            <instance>mtkRcs4</instance>
            <instance>mtkRsu1</instance>
            <instance>mtkRsu2</instance>
            <instance>mtkRsu3</instance>
            <instance>mtkRsu4</instance>
            <instance>mtkSe1</instance>
            <instance>mtkSe2</instance>
            <instance>mtkSe3</instance>
            <instance>mtkSe4</instance>
            <instance>mtkSlot1</instance>
            <instance>mtkSlot2</instance>
            <instance>mtkSlot3</instance>
            <instance>mtkSlot4</instance>
            <instance>mtkSmartRatSwitch1</instance>
            <instance>mtkSmartRatSwitch2</instance>
            <instance>mtkSmartRatSwitch3</instance>
            <instance>mtkSmartRatSwitch4</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.mtkradioex.data</name>
        <version>1-2</version>
        <interface>
            <name>IMtkRadioExData</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
            <instance>slot3</instance>
            <instance>slot4</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.mtkradioex.dch</name>
        <interface>
            <name>IMtkRadioExDc</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
            <instance>slot3</instance>
            <instance>slot4</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.mtkradioex.ims</name>
        <interface>
            <name>IMtkRadioExIms</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
            <instance>slot3</instance>
            <instance>slot4</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.mtkradioex.messaging</name>
        <interface>
            <name>IMtkRadioExMessaging</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
            <instance>slot3</instance>
            <instance>slot4</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.mtkradioex.modem</name>
        <version>1-2</version>
        <interface>
            <name>IMtkRadioExModem</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
            <instance>slot3</instance>
            <instance>slot4</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.mtkradioex.network</name>
        <interface>
            <name>IMtkRadioExNetwork</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
            <instance>slot3</instance>
            <instance>slot4</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.mtkradioex.rcs</name>
        <interface>
            <name>IMtkRadioExRcs</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
            <instance>slot3</instance>
            <instance>slot4</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.mtkradioex.sim</name>
        <interface>
            <name>IMtkRadioExSim</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
            <instance>slot3</instance>
            <instance>slot4</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.mtkradioex.voice</name>
        <interface>
            <name>IMtkRadioExVoice</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
            <instance>slot3</instance>
            <instance>slot4</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.netdagent</name>
        <version>1.0</version>
        <interface>
            <name>INetdagent</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.netdagent</name>
        <interface>
            <name>INetdagents</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.neuropilot.agent</name>
        <version>1.2</version>
        <interface>
            <name>IAgent</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.neuropilot.agent</name>
        <interface>
            <name>IAgent</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.nvram</name>
        <interface>
            <name>INvram</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.nvram</name>
        <version>1.1</version>
        <interface>
            <name>INvram</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.nwk_opt</name>
        <version>1.0</version>
        <interface>
            <name>INwkOpt</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.nwk_opt_new</name>
        <interface>
            <name>INwkOptNew</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.power</name>
        <version>2.1</version>
        <interface>
            <name>IPower</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.pplagent</name>
        <version>1.0</version>
        <interface>
            <name>IPplAgent</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.pq</name>
        <version>2.3-15</version>
        <interface>
            <name>IPictureQuality</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.pq_aidl</name>
        <version>1-6</version>
        <interface>
            <name>IPictureQuality_AIDL</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.presence</name>
        <version>1.0</version>
        <interface>
            <name>IPresence</name>
            <instance>presence_hal_service</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.radio_op</name>
        <version>2.0</version>
        <version>3.0</version>
        <interface>
            <name>IRadioOp</name>
            <instance>OpImsRILd1</instance>
            <instance>OpImsRILd2</instance>
            <instance>OpImsRILd3</instance>
            <instance>OpImsRILd4</instance>
            <instance>slot1</instance>
            <instance>slot2</instance>
            <instance>slot3</instance>
            <instance>slot4</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.rcs</name>
        <version>2.0</version>
        <interface>
            <name>IRcs</name>
            <instance>rcs_hal_service</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.rcs</name>
        <interface>
            <name>IRcs</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.sfs</name>
        <version>1.0</version>
        <interface>
            <name>ISFs</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.thp</name>
        <version>1.0</version>
        <interface>
            <name>ITHP</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.touchll</name>
        <version>1.0</version>
        <interface>
            <name>ITouchll</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.videotelephony</name>
        <version>1.0</version>
        <interface>
            <name>IVideoTelephony</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.mediatek.hardware.videotelephony</name>
        <interface>
            <name>IVideoTelephony</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.vpu</name>
        <version>1.0</version>
        <interface>
            <name>Ivpu</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.wifi.supplicant</name>
        <version>2.0</version>
        <interface>
            <name>ISupplicant</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.mediatek.hardware.wifi.supplicant</name>
        <version>2.2</version>
        <interface>
            <name>ISupplicant</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.tesiai.hardware.hdcpconnection</name>
        <version>1.0</version>
        <interface>
            <name>IHDCPConnection</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.trustonic.tee</name>
        <version>1.1</version>
        <interface>
            <name>ITee</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.trustonic.tee</name>
        <interface>
            <name>ITee</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.trustonic.tee.tui</name>
        <version>1.0</version>
        <interface>
            <name>ITui</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.trustonic.tui</name>
        <interface>
            <name>ITui</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.tsa.hdcp</name>
        <interface>
            <name>IHDCPInterface</name>
            <instance>default</instance>
        </interface>
    </hal>
    <sepolicy>
        <kernel-sepolicy-version>30</kernel-sepolicy-version>
        <sepolicy-version>29.0</sepolicy-version>
        <sepolicy-version>30.0</sepolicy-version>
        <sepolicy-version>31.0</sepolicy-version>
        <sepolicy-version>32.0</sepolicy-version>
        <sepolicy-version>33.0</sepolicy-version>
        <sepolicy-version>34.0</sepolicy-version>
    </sepolicy>
    <avb>
        <vbmeta-version>1.0</vbmeta-version>
    </avb>
</compatibility-matrix>
